//New password logic written with the help of this article:
//http://www.oreillynet.com/mac/blog/2006/07/giving_your_widget_that_sudo_v_1.html

var currentlyRunning = null;
var gRunButton;
var gDoneButton;
var gInfoButton;
var gCloseButton;
var gDownloadButton;
var doingCheck = false;
var xml_http = new XMLHttpRequest();

var dailychecked = true;
var weeklychecked = true;
var monthlychecked = true;

function setup ()
{
	ChangeSkin(getCurrentStyle());
    
    //Run Scripts button
    gRunButton = new AppleButton(
    	document.getElementById("runscripts"),
    	"Run Scripts",
    	22,
    	"button/left.png",
    	"button/left_down.png",
    	6,
    	"button/middle.png",
    	"button/middle_down.png",
    	"button/right.png",
    	"button/right_down.png",
    	6,
    	RunScripts);
        
    //Done button (back of widget)
    gDoneButton = new AppleGlassButton(
    	document.getElementById("doneButton"),
    	"Done",
    	hideCredits);
    	
   	//Little i button in upper right corner to flip widget
    gInfoButton = new AppleInfoButton(
    	document.getElementById("infoButton"),
    	document.getElementById("front"),
    	"white",
    	"white",
    	showCredits);
    	
    //Close button (version check)
    gCloseButton = new AppleGlassButton(
    	document.getElementById("closeButton"),
    	"Close",
    	hideVers);
    
    //Download button (version check)
    gDownloadButton = new AppleGlassButton(
    	document.getElementById("downloadButton"),
    	"Download",
    	downloadVers);
	
	//Get the dates and display them upon opening the dashboard
	checkdates();
}

//Each time a key is pressed, check to see if it was "Return." If so, try to
//run the scripts.
function PassChanged (theEvent)
{
	if (String.fromCharCode(theEvent.which) == "\r")
		RunScripts();
}

//Called when a user enters their password and hits return or clicks Run Scrips
function RunScripts ()
{
	var pass;
	var command;
	var scriptstr;
	var userpass;
	
	if(window.widget)
	{	
		document.getElementById("infoButton").style.display = "none";
		
		//Clear out any old sudo commands
		command = widget.system("/usr/bin/sudo -K", null);
	
		//Get the password
		userpass = document.getElementById("password").value;
		pass = userpass.replace(/\\/g, "\\\\\\\\");  //Replace single backslashes with four backslashes
		pass = pass.replace(/\"/g, "\\\"");
        pass = pass.replace(/\!/g, "\\\!");
        pass = pass.replace(/\@/g, "\\\@");
        pass = pass.replace(/\#/g, "\\\#");
        pass = pass.replace(/\$/g, "\\\$");
        pass = pass.replace(/\%/g, "\\\%");
        pass = pass.replace(/\^/g, "\\\^");
        pass = pass.replace(/\&/g, "\\\&");
        pass = pass.replace(/\*/g, "\\\*");
        pass = pass.replace(/\?/g, "\\\?");
		
		//If the last run of the scripts is still going, cancel it
		if (currentlyRunning != null)
			currentlyRunning.cancel();
		
		//Set up the command to be run. This is where the magic of getting sudo
		//to work in the dashboard happens.
		scriptstr = '/usr/bin/printf "' + pass.toString() + '\n" | /usr/bin/sudo -S /usr/sbin/periodic';
		
		//If thecheckboxes are checked, add those scripts to the run command.
		if (dailychecked)
			scriptstr = scriptstr + ' /etc/periodic/daily';
		if (weeklychecked)
			scriptstr = scriptstr + ' /etc/periodic/weekly';
		if (monthlychecked)
			scriptstr = scriptstr + ' /etc/periodic/monthly';
		
		//Run the command asyncronously (doneTryingScripts is called when the
		//command is finished)
		currentlyRunning = widget.system(scriptstr, doneTryingScripts);
		
		//After trying to run the command, alert the user depending on if the
		//password was accepted or not.
		currentlyRunning.onreaderror = passwordError;
		
		//Make the user re-enter a password to re-run the scripts
		//Also will keep them safe from running other commands in the terminal
		//with root access without typing sudo in the terminal
		command = widget.system("/usr/bin/sudo -K", null);
		
		//Reset the password field
		document.getElementById("password").value = "";
	}
}

// checkdates() is called every time Dashboard is shown
function checkdates ()
{
	var s1, s2, s3;
	
	if(window.widget)
	{
		//Run the perl scripts and update the text elements in the HTML
		s1 = widget.system("/usr/bin/perl parser.pl 'daily.out'", null).outputString;
		s2 = widget.system("/usr/bin/perl parser.pl 'weekly.out'", null).outputString;
		s3 = widget.system("/usr/bin/perl parser.pl 'monthly.out'", null).outputString;
		
		if (s1==undefined)
			document.getElementById("dailytext").innerText = "Not yet run";
		else
			document.getElementById("dailytext").innerText = s1;
		
		if (s2==undefined)
			document.getElementById("weeklytext").innerText = "Not yet run";
		else
			document.getElementById("weeklytext").innerText = s2;
		
		if (s3==undefined)
			document.getElementById("monthlytext").innerText = "Not yet run";
		else
			document.getElementById("monthlytext").innerText = s3;
	}
}

// reset() is called every time Dashboard is hidden
function reset ()
{
	document.getElementById("dailytext").innerText = "Retrieving...";
	document.getElementById("weeklytext").innerText = "Retrieving...";
	document.getElementById("monthlytext").innerText = "Retrieving...";
}

// remove is called when the user removes the widget from the Dashboard
function remove()
{
	widget.setPreferenceForKey(null,"style");
}

//Sync the preferences in MobileMe
function syncPrefs()
{
	ChangeSkin(getCurrentStyle());
}

// here, we sign up for the Dashboard show and hide events
if(window.widget)
{
	widget.onshow = checkdates;
	widget.onhide = reset;
	widget.onremove = remove;
	widget.onsync = syncPrefs;
}

//Done running the scripts event handler
function doneTryingScripts(cmd)
{	
	if (cmd.status == 1)
		document.getElementById("passwordfailed").style.display="block";
	else
		document.getElementById("infoButton").style.display = "block";
	
	document.getElementById("passwordaccepted").style.display="none";
	checkdates();
	
	//Reset the "running" object, hide the div that indicates the scripts are
	//running
	currentlyRunning = null;
}

//Misleading name, as it checks if the password was accepted or rejected.
//If rejected, the return status of "sudo" is 1.
function passwordError(stderr)
{
	if (currentlyRunning.status == 1)
		document.getElementById("passwordfailed").style.display="block";
	else
		document.getElementById("passwordaccepted").style.display="block";
}

//Show the back side of the widget when the 'i' button is clicked
function showCredits()
{
    var front = document.getElementById("front");
    var back = document.getElementById("back");
 
    if (window.widget)
        widget.prepareForTransition("ToBack");
 
    front.style.display="none";
    back.style.display="block";
 
    if (window.widget)
        setTimeout ('widget.performTransition();', 0);  
}

//Flip back over the the front side when Done is clicked
function hideCredits()
{
    var front = document.getElementById("front");
    var back = document.getElementById("back");
 
    if (window.widget)
        widget.prepareForTransition("ToFront");
 
    back.style.display="none";
    front.style.display="block";
 
    if (window.widget)
        setTimeout ('widget.performTransition();', 0);
}

//Hide the password failed div when the user clicks it
function hidePassBox()
{
	document.getElementById("passwordfailed").style.display="none";
	document.getElementById("infoButton").style.display = "block";
}

//Called when the user clicks the link on the back of the widget
function openWebPage()
{
	widget.openURL("http://www.giantmike.com/widgets/Maintidget.html");
}

function openWebPage2()
{
	widget.openURL("http://homedsl.co.uk");
}

//Called chen user clicks the check box next to the daily output
function clickeddaily()
{
	//If false, then set true and vice versa
	dailychecked = !dailychecked;
	
	//Set the image
	if (dailychecked)
		document.getElementById("dailycheck").src = getCurrentStyle() + "/checked.png";
	else
		document.getElementById("dailycheck").src = getCurrentStyle() + "/unchecked.png";
	
	togglePassword();
}

//Called chen user clicks the check box next to the weekly output
function clickedweekly()
{
	//If false, then set true and vice versa
	weeklychecked = !weeklychecked;
	
	//Set the image
	if (weeklychecked)
		document.getElementById("weeklycheck").src = getCurrentStyle() + "/checked.png";
	else
		document.getElementById("weeklycheck").src = getCurrentStyle() + "/unchecked.png";
	
	togglePassword();
}

//Called chen user clicks the check box next to the monthlyly output
function clickedmonthly()
{
	//If false, then set true and vice versa
	monthlychecked = !monthlychecked;
	
	//Set the image
	if (monthlychecked)
		document.getElementById("monthlycheck").src = getCurrentStyle() + "/checked.png";
	else
		document.getElementById("monthlycheck").src = getCurrentStyle() + "/unchecked.png";
	
	togglePassword();
}

//disable password entry when no scripts selected to run
function togglePassword()
{
	if (dailychecked || weeklychecked || monthlychecked)
	{
		document.getElementById("password").disabled = false;
		gRunButton.setEnabled(true);
	}
	else
	{
		document.getElementById("password").disabled = true;
		gRunButton.setEnabled(false);
	}
}

function getCurrentStyle()
{
	var style = widget.preferenceForKey("style");
	
	if (style == null)
    	return "silver";
    
    return style;
}

//Open the specified log file in Console.app
//We use the -b argument to specify that we want to open the file in
//  the com.apple.Console bundle (language independent)
function openLog(name)
{
	widget.system("/usr/bin/open -b com.apple.Console /var/log/" + name, null);
}


//Check the currently installed version against the version on the server.
//Depending on the outcome of this check, we will allow them to download the new
//version if they click the 'Download' button.
function doVersCheck()
{
	document.getElementById("versionbox").style.display = "block";
	document.getElementById("versionboxtext").innerHTML = "Checking for newer version...";
	document.getElementById("downloadButton").style.display = "none";
	document.getElementById("closeButton").style.right = "115px";
	document.getElementById("closeButton").style.bottom = "4px";
	getServerVersion();

}

//Hide the version check box
function hideVers()
{
	if (doingCheck)
		xml_http.abort();
	document.getElementById("versionbox").style.display = "none";
}

//Download the latest version, then hide the the version check box
function downloadVers()
{
	widget.openURL("http://www.giantmike.com/progs/Maintidget.zip");
	hideVers();
}

//Gets the version of the widget using the version set in info.plist
function getCurrentVersion()
{ 
	var xml_local = new XMLHttpRequest();
	xml_local.open("GET", "Info.plist", false);
	xml_local.send(null);
	
	var xmlText = xml_local.responseText;
	var key = "CFBundleVersion";
	
	//parse code from http://www.dashboardwidgets.com/forums/viewtopic.php?t=689
	var offset = xmlText.indexOf('<key>'+key+'</key>',0) + 11 + key.length; 
	offset = xmlText.indexOf('>',offset) + 1;
	var offset2 = xmlText.indexOf('<',offset);
	return xmlText.substring(offset,offset2);
	
}

//Gets the version of the widget using a special text file on the server that
//contains the 
function getServerVersion()
{
	doingCheck=true;
	xml_http.onreadystatechange = ServerCheckDone;  //This delays the ending of the event
	xml_http.open("GET", "http://www.giantmike.com/widgets/maintidget-version.txt", true);
	xml_http.send(null);
}

//Depending on the outcome of the server check, we will allow them to download
//the new version if they click the 'Download' button.
function ServerCheckDone()
{
	if (xml_http.readyState != 4) //Readystate of 4 means the request completed
		return;
	doingCheck=false;
	var obj = document.getElementById("versionboxtext");
	var newVers = xml_http.responseText;
	
	if (xml_http.status != 200)  //Status of 200 means the request was good
	{
		obj.innerHTML="Could not connect to server.<br>Please try again later.";
		document.getElementById("downloadButton").style.display = "none";
		document.getElementById("closeButton").style.right = "115px";
		document.getElementById("closeButton").style.bottom = "3px";
		return;
	}
	
	if (getCurrentVersion() == newVers)
	{
		obj.innerHTML="You already have the latest version.";
		document.getElementById("downloadButton").style.display = "none";
		document.getElementById("closeButton").style.right = "115px";
	}
	else
	{
		obj.innerHTML="A newer version ("+newVers+") is available.";
		document.getElementById("downloadButton").style.display = "block";
		document.getElementById("closeButton").style.right = "70px";
	}
}


function ChangeSkin(title)
{
	var i, arr;
	arr = document.getElementsByTagName("link");
	
  	for(i=0; i<arr.length; i++)
  	{
    	arr[i].disabled = true;
    	if(arr[i].getAttribute("title") == title)
    		arr[i].disabled = false;
  	}
  	document.getElementById(title+"M").selected = true;
  	
  	if (dailychecked)
		document.getElementById("dailycheck").src = title + "/checked.png";
	else
		document.getElementById("daillycheck").src = title + "/unchecked.png";
  	
  	if (weeklychecked)
		document.getElementById("weeklycheck").src = title + "/checked.png";
	else
		document.getElementById("weeklycheck").src = title + "/unchecked.png";
		
	if (monthlychecked)
		document.getElementById("monthlycheck").src = title + "/checked.png";
	else
		document.getElementById("monthlycheck").src = title + "/unchecked.png";
  	
  	widget.setPreferenceForKey(title,"style");  	
}